Bug 1119095 - Review Request: python-djvulibre - Python bindings to DjVuLibre
Review Request: python-djvulibre - Python bindings to DjVuLibre
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Michel Alexandre Salim
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2014-07-13 20:56 EDT by Brian Stinson
Modified: 2015-07-21 08:56 EDT (History)
3 users (show)

See Also:
Fixed In Version: python-djvulibre-0.3.9-3.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-08-07 07:47:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
michel: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Brian Stinson 2014-07-13 20:56:43 EDT
Spec URL: http://www-personal.ksu.edu/~bstinson/rpms/python-djvulibre/python-djvulibre.spec

SRPM URL: http://www-personal.ksu.edu/~bstinson/rpms/python-djvulibre/python-djvulibre-0.3.9-1.fc21.src.rpm

Koji URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=7135389

Description: Python bindings to DjVuLibre - the Open Source implementation of the DjVu digital document format

Fedora Account System Username: bstinson

This is my first package contribution to Fedora, and I hope to provide builds for a couple of tools that rely on python-djvulibre soon.
Comment 1 Jamie Duncan 2014-07-13 22:30:38 EDT
A 'non-official' review.

rpmlint is totally clean:

Checking: python-djvulibre-0.3.9-1.fc20.x86_64.rpm
          python-djvulibre-0.3.9-1.fc20.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.

BuildRoot Tag:
this is only required for EPEL 5 and older. might want to wrap that around some logic.
http://fedoraproject.org/wiki/Packaging:Guidelines#BuildRoot_tag

Python Macros:
These should probably be updated to %{__python2}, etc.
http://fedoraproject.org/wiki/Packaging:Python#Macros

BuildRequires:
Need to add python2-devel, etc. so it builds properly in the build system. You're listing python-devel, but that may get confusing down the road when Py3 becomes the default. 
http://fedoraproject.org/wiki/Packaging:Python#BuildRequires

defattr at top of %files:
This isn't required anymore.
http://fedoraproject.org/wiki/Packaging:Guidelines#File_Permissions

The module itself imports cleanly.

Other than picking those nits, it looks good. Welcome to Fedora! 

Cheers,

Jamie Duncan
Comment 2 Christopher Meng 2014-07-13 23:50:33 EDT
%if 0%{?rhel} && 0%{?rhel} <= 5
%global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
%define python_version %(%{__python} -c 'import sys;print(sys.version[0:3])')
%endif 

You should drop them, RHEL5 only ships python2.4, you need to ensure that it works actually.

--------

# Don't check the example scripts in the documentation for dependencies
%global __requires_exclude_from  ^(%{_defaultdocdir}/%{name}/examples/.*)$

Why not chmod 644 to them?

--------

Meanwhile I guess you are packaging ocrodjvu or djvusmooth?
Comment 3 Michel Alexandre Salim 2014-07-14 05:49:00 EDT
Taking this, will sponsor.
Comment 4 Brian Stinson 2014-07-14 20:06:34 EDT
Thanks for the welcome Christopher, Jamie, and Michel! I've updated the spec and SRPM to remove the old preamble, use python2 macros and fix some permissions. To answer Christopher's question, this is a precursor to looking at djvusmooth. 

Updated SPEC: http://www-personal.ksu.edu/~bstinson/rpms/python-djvulibre/python-djvulibre.spec

Update SRPM: http://www-personal.ksu.edu/~bstinson/rpms/python-djvulibre/python-djvulibre-0.3.9-2.fc21.src.rpm

I completed rpmlint-clean local mockbuilds on f19,f20,f21,el6, and epel7 using this spec.

--Brian
Comment 5 Michel Alexandre Salim 2014-07-15 23:58:39 EDT
Hi Brian,

Some notes regarding your latest revision -- the spec you link to is not the spec used to build the SRPM, there's a typo in the latter.

Also you're using both %{buildroot} and $RPM_BUILD_ROOT -- you want to consistently use one (doesn't matter which), and since you only use $RPM_BUILD_ROOT twice (and the first, wiping the build root in %install, is only needed if you plan to build for el5), I'd suggest sticking with buildroot.

cf https://fedoraproject.org/wiki/EPEL:Packaging#Prepping_BuildRoot_For_.25install  

$ diff -u srpm/python-djvulibre.spec srpm-unpacked/python-djvulibre.spec
--- srpm/python-djvulibre.spec	2014-07-16 10:41:22.097479760 +0700
+++ srpm-unpacked/python-djvulibre.spec	2014-07-15 06:41:48.000000000 +0700
@@ -53,7 +53,7 @@
 rm -rf $RPM_BUILD_ROOT
 %{__python2} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
 
-# Fix non-standard (0775) executable permissions on private shared libraries
+# Fix non-standard executable permissions on private shared libraries
 %{__chmod} 0755 %{buildroot}%{python2_sitearch}/djvu/sexpr.so
 %{__chmod} 0755 %{buildroot}%{python2_sitearch}/djvu/decode.so
 
@@ -66,7 +66,7 @@
 
 %changelog
 * Mon Jul 14 2014 Brian Stinson <bstinson@ksu.edu> - 0.3.9-2
-- Incorporate suggested macro removals and changes from jduncan and cicku
+- Incorporate suggested macro removals and changes from jducan and cicku
 
 * Sun Jul 13 2014 Brian Stinson <bstinson@ksu.edu> - 0.3.9-1
 - Initial Build
Comment 6 Michel Alexandre Salim 2014-07-16 00:21:01 EDT
Full review -- there are several more issues

Summary:
- documentation probably should be split (end users don't need them)
- you should run the tests that upstream provide

Apart from these and the initial issues from the previous comments this look quite good, hopefully we can get this in soon. Nice work!


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros


===== MUST items =====

C/C++:
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
     => this is expected

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2)", "Unknown or generated". 2 files have unknown license.
     Detailed output of licensecheck in
     /home/michel/sources/fedora/reviews/1119095-python-
     djvulibre/licensecheck.txt

     License should be GPLv2, not GPLv2+

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory names).
     see previous comment
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[-]: Package is not known to require an ExcludeArch tag.
[!]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 563200 bytes in 53 files.

     Documentation is about as big as the rest of the package, I'd
     suggest splitting a -doc subpackage as it's only needed by
     developers, not users of apps that use djvulibre

[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
     will do a scratch build in Koji later
[!]: %check is present and all tests pass.
     There are some test files in tests/ that should be easily
     runnable (requires additional BuildRequires on python-nose),
     might want to run them

[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: python-djvulibre-0.3.9-2.fc20.x86_64.rpm
          python-djvulibre-0.3.9-2.fc20.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-djvulibre
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Diff spec file in url and in SRPM
---------------------------------
--- /home/michel/sources/fedora/reviews/1119095-python-djvulibre/srpm/python-djvulibre.spec	2014-07-16 10:41:22.097479760 +0700
+++ /home/michel/sources/fedora/reviews/1119095-python-djvulibre/srpm-unpacked/python-djvulibre.spec	2014-07-15 06:41:48.000000000 +0700
@@ -54,5 +54,5 @@
 %{__python2} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
 
-# Fix non-standard (0775) executable permissions on private shared libraries
+# Fix non-standard executable permissions on private shared libraries
 %{__chmod} 0755 %{buildroot}%{python2_sitearch}/djvu/sexpr.so
 %{__chmod} 0755 %{buildroot}%{python2_sitearch}/djvu/decode.so
@@ -67,5 +67,5 @@
 %changelog
 * Mon Jul 14 2014 Brian Stinson <bstinson@ksu.edu> - 0.3.9-2
-- Incorporate suggested macro removals and changes from jduncan and cicku
+- Incorporate suggested macro removals and changes from jducan and cicku
 
 * Sun Jul 13 2014 Brian Stinson <bstinson@ksu.edu> - 0.3.9-1


Requires
--------
python-djvulibre (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdjvulibre.so.21()(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    python(abi)
    rtld(GNU_HASH)



Provides
--------
python-djvulibre:
    python-djvulibre
    python-djvulibre(x86-64)



Unversioned so-files
--------------------
python-djvulibre: /usr/lib64/python2.7/site-packages/djvu/decode.so
python-djvulibre: /usr/lib64/python2.7/site-packages/djvu/sexpr.so

Source checksums
----------------
https://pypi.python.org/packages/source/p/python-djvulibre/python-djvulibre-0.3.9.tar.gz :
  CHECKSUM(SHA256) this package     : ca11e57ae14161788ba8ee48063136f3fa12aad887035a36c3b2bfb8346c1a44
  CHECKSUM(SHA256) upstream package : ca11e57ae14161788ba8ee48063136f3fa12aad887035a36c3b2bfb8346c1a44


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/bin/fedora-review -b 1119095 -m fedora-20-x86_64
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 7 Brian Stinson 2014-07-16 20:11:08 EDT
Hi Michel,
Sorry about the mismatch, I accidentally uploaded the wrong srpm that time around. Here are my changes for macro consistency, correcting the license, adding tests, and splitting the docs into a subpackage:

SPEC: http://www-personal.ksu.edu/~bstinson/rpms/python-djvulibre/python-djvulibre.spec
SRPM: http://www-personal.ksu.edu/~bstinson/rpms/python-djvulibre/python-djvulibre-0.3.9-3.fc21.src.rpm


--Brian
Comment 8 Michel Alexandre Salim 2014-07-17 06:33:50 EDT
Hi Brian,

Everything looks good -- this package is APPROVED

Let me know your FAS username and I'll sponsor it.

Feel free to look me up for packaging questions in the future, and welcome again!
Comment 9 Brian Stinson 2014-07-17 10:01:51 EDT
Great! Thanks for guiding me through this one. I might have a couple of minor questions that I'll send to you out-of-band. My FAS username is bstinson. Is the next step for this package an SCM request? 

--Brian
Comment 10 Michel Alexandre Salim 2014-07-17 23:32:19 EDT
Hi Brian,

I had to sponsor you first, otherwise your SCM request can't be processed properly. I've done that now, so do go ahead.

I'm michel_slm on IRC and you have my email .. good luck!
Comment 11 Brian Stinson 2014-07-18 09:56:22 EDT
New Package SCM Request
=======================
Package Name: python-djvulibre
Short Description: Python bindings to DjVuLibre
Upstream URL: http://jwilk.net/software/python-djvulibre
Owners: bstinson 
Branches: f19 f20 f21 el6 epel7
InitialCC:
Comment 12 Jon Ciesla 2014-07-18 10:55:32 EDT
Git done (by process-git-requests).
Comment 13 Fedora Update System 2014-07-18 22:35:36 EDT
python-djvulibre-0.3.9-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-djvulibre-0.3.9-3.el6
Comment 14 Fedora Update System 2014-07-20 14:01:00 EDT
python-djvulibre-0.3.9-3.el6 has been pushed to the Fedora EPEL 6 testing repository.
Comment 15 Fedora Update System 2014-08-07 07:47:25 EDT
python-djvulibre-0.3.9-3.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.